
//	Copyright 2010 PaletteSoft LLC

// ***************************************************************************
// *	dl															 *
// ***************************************************************************
/*
	kdc\Tv@̂P	PIC12F683	CLOCK:INTRCIO/4MHz

	GP0:LED0	Out	0:A1:_
	GP1:LED1	Out	0:A1:_
	GP2:LED2	Out	0:A1:_
	GP3:MCLR	-----
	GP4:SW1		In	0:IA1:It	vAbvp̂
	GP5:SW0		In	0:IA1:It	vAbvp̂

	LED0->LED1->LED2->LED0c̏łP̂kdcPbԓ_B

	荞݂͎gpdelay֐𗘗pB
*/

// ***************************************************************************
// *	CN[ht@C												 *
// ***************************************************************************

#include	<pic.h>														//	vWFNgݒőIꂽfoCXIɈp܂

// ***************************************************************************
// *	vOo[W												 *
// ***************************************************************************

#define	VER1					1										//	ʏ\̈	PŎwip֎~j
#define	VER2					0										//	ʈ̈	PŎwip֎~j
//								.
#define	VER3					1										//	ʏ\̈	PŎwip֎~j
#define	VER4					3										//	ʈ̈	PŎwip֎~j

#define	COPYRIGHT				"Copyright 2010 PaletteSoft LLC"		//	쌠

// ***************************************************************************
// *																 *
// ***************************************************************************

	//	*****  *****

__CONFIG(	FCMDIS														//	tF[Z[tNbNj^֎~
		&	IESODIS														//	ONbÑXCb`I[o[[h֎~
		&	BORDIS														//	uEAEgo֎~
		&	UNPROTECT													//	f[^iEEPROMj̃veNg֎~
		&	UNPROTECT													//	vÕveNg֎~
		&	MCLREN														//	GP3/_MCLR[q_MCLRŗpiIɃvAbvj
		&	PWRTEN														//	p[Abv^C}싖
		&	WDTDIS														//	EHb`hbO^C}֎~
		&	INTIO														//	NbNpRA4ARA5[q͓o͂ŗp
);

	//	***** hc *****

__IDLOC7(VER1, VER2, VER3, VER4);										//	o[WԍƂĒ`ïӖt͔CӁj

	//	***** U *****

#define	_XTAL_FREQ				4000000									//	gigj		c@__delay_XXňp

// ***************************************************************************
// *	f[^^															 *
// ***************************************************************************

typedef	unsigned char			UB;										//	PoCgf[^^
typedef	unsigned short			UH;										//	QoCgf[^^
typedef	unsigned int			UINT;									//	Ȃ

// ***************************************************************************
// *	Œl																 *
// ***************************************************************************

#define	LED_PATTERN_MAX			3										//	kdc̃p^[

// ***************************************************************************
// *	O[oϐ														 *
// ***************************************************************************

union {
	UB	BYTE;															//	oCgANZXp
	struct {
		UINT	Led		: 3;											//	kdc				c@ʂRrbg
		UINT	Dummy	: 5;											//	_~[
	} BIT;
} vPortData;															//	o̓|[g̃obNAbv

UB		vLedPos;														//	kdc̕\ʒu

// ***************************************************************************
// *	e[u															 *
// ***************************************************************************

const	UB		tLedPattern[LED_PATTERN_MAX] = {						//	kdcp^[
					0b001, 0b010, 0b100									//	LED0 -> LED1 -> LED2
};

// ***************************************************************************
// *	}N錾															 *
// ***************************************************************************

	//	***** ԑҋ@ *****

#ifdef	__DEBUG															//	fobO[hH
#define	mWait(Value)			__delay_us(Value)						//	ʂPʂ̑ҋ@			c@V~[V͐{ŃEGCg
#else																	//	^[Qbg[h
#define	mWait(Value)			__delay_ms(Value)						//	Pʂ̑ҋ@
#endif

// ***************************************************************************
// *	vg^Cv錾													 *
// ***************************************************************************

void	main(void);
void	WaitTime(void);
void	LedCtrl(void);
void	DevInit(void);

// ***************************************************************************
// *	{															 *
// ***************************************************************************

//============================================================================
//	C
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	X^[gAbv[`̃Wv߂ŌĂяo܂B
//			{֐͖[vłAEo邱Ƃ͂܂B
//============================================================================
void	main(void)
{
	//	***** ͂߂ *****

	di();																//	Ă̊荞݋֎~𖾎
	DevInit();															//	foCXݒ

	vLedPos = 0;														//	kdc̕\ʒu擪

	//	*****  *****

	while (1) {															//	[vł
		WaitTime();														//	ҋ@
		LedCtrl();														//	kdc
	}
}

//============================================================================
//	ҋ@
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	PbԂ̑ҋ@s܂B
//============================================================================
void	WaitTime(void)
{
	UB		Loop;														//	[vJE^

	for (Loop=0; Loop<100; Loop++) {									//	POO񏄉
		mWait(10);														//	PȎҋ@			c@V~[Vƃ^[QbgœقȂ
	}
}

//============================================================================
//	kdc
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	\ʒuɑΉkdcf[^o͂܂B
//			p̂ŃobNAbv̈`Ă̂ŁArbgʒuAsvrbg
//			̊Ǘ̓RpCɔCĂ܂B
//============================================================================
void	LedCtrl(void)
{
	UB		LedData;													//	kdc\f[^

	//	***** kdc\ *****

	LedData = tLedPattern[vLedPos];										//	kdc\f[^擾

	vPortData.BIT.Led = LedData;										//	kdco̓f[^XV	c@RpCrbgʒu킹
	GPIO = vPortData.BYTE;												//	o̓|[gꊇҏW	c@rbgɂRead&ModifysȂ@

	//	***** \ʒuXV *****

	if (++vLedPos >= LED_PATTERN_MAX) {									//	\ʒuXVvfI[o[H
		vLedPos = 0;													//	\ʒu擪
	}
}

//============================================================================
//	foCXݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	foCX̏ݒs܂B
//			Zbg̏lōςޏꍇ͍Đݒ肵Ă܂B
//============================================================================
void	DevInit(void)
{
	//	***** { *****

//						  76543210
	OPTION =			0b01111111;										//	IvVWX^
																		//	bit07:GPPU		0	̓|[g̃vAbv			
																		//	bit06:INTEDG	1	O荞݂͗オGbW		gp
																		//	bit05:T0CS		1	^C}O͊ONbN𗘗p		gp
																		//	bit04:T0SE		1	^C}O̍XV͗GbW		gp
																		//	bit03:PSA		1	vXP[͂vcsŗp			gp
																		//	bit02:PS2		1	vXP[͂PQW			gp
																		//	bit01:PS1		1		ij
																		//	bit00:PS0		1		ij

	//	***** o̓|[g *****										//	ӁFĂ̏ꍇAėpo̓|[g͕ʋ@\Ă

//						  76543210
	vPortData.BYTE =	0b00000000;										//	ėpo̓|[gf[^̏l
																		//	bit07:-----		0
																		//	bit06:-----		0
																		//	bit05:GP5		0	́FrvO						͂Ȃ̂ŖӖ
																		//	bit04:GP4		0	́FrvP						͂Ȃ̂ŖӖ
																		//	bit03:GP3		0	́Flbkq						w͖
																		//	bit02:GP2		0	óFkdcQ						
																		//	bit01:GP1		0	óFkdcP						
																		//	bit00:GP0		0	óFkdcO						

	GPIO = vPortData.BYTE;												//	o̓|[gꊇҏW	c@rbgɂRead&ModifysȂ@

//						  76543210
	CMCON0 =			0b00000111;										//	Rp[^
																		//	bit07:-----		0
																		//	bit06:COUT		0	Rp[^o͏				ǂݏô݉
																		//	bit05:-----		0
																		//	bit04:CINV		0	o͔]Ȃ						gp
																		//	bit03:CIS		0	̓XCb`ݒ					gp
																		//	bit02:CM2		1	Rp[^It					
																		//	bit01:CM1		1		ij						
																		//	bit00:CM0		1		ij						

//						  76543210
	ANSEL =				0b00000000;										//	AiOZN^
																		//	bit07:-----		0
																		//	bit06:ADCS2		0	`cϊNbNI				gp
																		//	bit05:ADCS1		0		ij
																		//	bit04:ADCS0		0		ij
																		//	bit03:ANS3		0	`mRgpAfoSėpo		
																		//	bit02:ANS2		0	`mQgpAfoQėpo		
																		//	bit01:ANS1		0	`mPgpAfoPėpo		
																		//	bit00:ANS0		0	`mOgpAfoOėpo		

//						  76543210
	TRISIO =			0b00111000;										//	ėpo̓|[g
																		//	bit07:-----		0
																		//	bit06:-----		0
																		//	bit05:GP5		1	́FrvO						
																		//	bit04:GP4		1	́FrvP						
																		//	bit03:GP3		1	́Flbkq						ǂݏô݉
																		//	bit02:GP2		0	óFkdcQ						
																		//	bit01:GP1		0	óFkdcP						
																		//	bit00:GP0		0	óFkdcO						
}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

//	Copyright 2010 PaletteSoft LLC

